Vending Machine Kata
====================

In this exercise you will build the brains of a vending machine.  It will accept money, make change, maintain
inventory, and dispense products.  All the things that you might expect a vending machine to accomplish.

The point of this kata to to provide a larger than trivial exercise that can be used to practice TDD.  A significant
portion of the effort will be in determining what tests should be written and, more importantly, written next.

Preliminary Design
==================
Vending machine that tracks:
  - state
  - action to perform
  - display value
  - coin slot total (total deposited into coin slot)
  - machine total (total in the machine)
  - change total
  - products
      - name
      - cost
      - quanity

Kata Challenge 1 - Dispense coins
=======================
Figure out what coins to dispense to give users change
  - coins
      - size
      - weight
      - value
      - quantity

Kata  Challenge 3 - Credit card
======================
Add attribute cardTotal
Add method chargeCard(amount)

Kata Challenge 4 - Foreign credit card
======================================
Add method chargeCard(amount, currency)
Find API for converting currency to dollars

Kata Challenge 5 - Storage
=========================
Store vending machine data so on restart app remembers
attribute values

Kata Challenge 6 - Build UI
===========================

Features
========

Accept Coins
------------
*Story*  
_As a vendor_  
_I want a vending machine that accepts coins_  
_So that I can collect money from the customer_  

The vending machine will accept valid coins (nickels, dimes, and quarters) and reject invalid ones (pennies).  When a
valid coin is inserted the amount of the coin will be added to the current amount and the display will be updated.
When there are no coins inserted, the machine displays INSERT COIN.  Rejected coins are placed in the coin return.

*Tests*
- When a vending machine is installed, then the initial deposit total is 0.
- Given a vending machine is installed, when an amount is deposited into a vending machine, when an amount is deposited,
the amount accumulates to the deposit total
- Given a vending machine with 0.75 total deposit, when a coin of a certain weight and size is deposited into a vending machine,
the amount  is based on the weight and size
- When the deposited total is zero, the vending machine display value is "INSERT COIN" and 
state is "Waiting"

NOTE: The temptation here will be to create Coin objects that know their value.  However, this is not how a real
  vending machine works.  Instead, it identifies coins by their weight and size and then assigns a value to what
  was inserted.  You will need to do something similar.  This can be simulated using strings, constants, enums,
  symbols, or something of that nature.

Select Product
--------------

_As a vendor_  
_I want customers to select products_  
_So that I can give them an incentive to put money in the machine_  

There are three products: cola for $1.00, chips for $0.50, and candy for $0.65.  When the respective button is pressed
and enough money has been inserted, the product is dispensed and the machine displays THANK YOU.  If the display is
checked again, it will display INSERT COIN and the current amount will be set to $0.00.  If there is not enough money
inserted then the machine displays PRICE and the price of the item and subsequent checks of the display will display
either INSERT COIN or the current amount as appropriate.
- The vending machine has three products
- The price of "cola" is 1.00, "chips" is 0.50, and "candy" is 0.65
- When a button is pressed for a product and exactly enough money was entered, 
     - display value is "Thank you" 
     - depositTotal == 0
     - state = "dispense soda"
- Same if more than enough money
- When a button is pressed for a product and not enough money is provided,
display value is "Price is <price>"

Make Change
-----------

_As a vendor_  
_I want customers to receive correct change_  
_So that they will use the vending machine again_  

When a product is selected that costs less than the amount of money in the machine, then the remaining amount is placed
in the coin return.

Return Coins
------------

_As a customer_  
_I want to have my money returned_  
_So that I can change my mind about buying stuff from the vending machine_  

When the return coins button is pressed, the money the customer has placed in the machine is returned and the display shows
INSERT COIN.

Sold Out
--------

_As a customer_  
_I want to be told when the item I have selected is not available_  
_So that I can select another item_  

When the item selected by the customer is out of stock, the machine displays SOLD OUT.  If the display is checked again,
it will display the amount of money remaining in the machine or INSERT COIN if there is no money in the machine.

Exact Change Only
-----------------

_As a customer_  
_I want to be told when exact change is required_  
_So that I can determine if I can buy something with the money I have before inserting it_  

When the machine is not able to make change with the money in the machine for any of the items that it sells, it will
display EXACT CHANGE ONLY instead of INSERT COIN.